-- POSSIBLY REPLACE WITH BRAVEN'S UTILS DEPENDENCY!
local DelayFunction = function(func, delay)

    delay = delay or 1;
    local ticks = 0;
    local canceled = false;

    local function onTick()

        if not canceled and ticks < delay then
            ticks = ticks + 1;
            return;
        end

        Events.OnTick.Remove(onTick);
        if not canceled then func(); end
    end

    Events.OnTick.Add(onTick);
    return function()
        canceled = true;
    end
end

local function onPlayerAttacked(playerObj, handWeapon)

    local weaponName = handWeapon:getType(); if not weaponName then return end

    if string.contains(weaponName, "Throwable") then

        local isRetrievable = handWeapon:canBeReused(); if not isRetrievable then return end

		-- Simulate the player retrieved the item. TEMPORARY FIX!
		DelayFunction(function()
            playerObj:getInventory():AddItem(handWeapon:getFullType())
		end, 500);
    end
end

Events.OnPlayerAttackFinished.Add(onPlayerAttacked)